"""driver, passenger, vehicle, fleet and ride tables

Revision ID: d23c2d48a82e
Revises: 
Create Date: 2018-09-03 19:22:45.737199

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'd23c2d48a82e'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('fleet',
    sa.Column('f_id', sa.BigInteger(), nullable=False),
    sa.Column('fleet_for', sa.String(), nullable=False),
    sa.Column('location', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.PrimaryKeyConstraint('f_id'),
    sa.UniqueConstraint('location')
    )
    op.create_index(op.f('ix_fleet_created_at'), 'fleet', ['created_at'], unique=False)
    op.create_index(op.f('ix_fleet_updated_at'), 'fleet', ['updated_at'], unique=False)
    op.create_table('passenger',
    sa.Column('p_id', sa.BigInteger(), nullable=False),
    sa.Column('name', sa.String(length=40), nullable=False),
    sa.Column('email', sa.String(), nullable=False),
    sa.Column('mobile', sa.String(length=10), nullable=False),
    sa.Column('password_hash', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.PrimaryKeyConstraint('p_id')
    )
    op.create_index(op.f('ix_passenger_created_at'), 'passenger', ['created_at'], unique=False)
    op.create_index(op.f('ix_passenger_email'), 'passenger', ['email'], unique=True)
    op.create_index(op.f('ix_passenger_mobile'), 'passenger', ['mobile'], unique=True)
    op.create_index(op.f('ix_passenger_name'), 'passenger', ['name'], unique=False)
    op.create_index(op.f('ix_passenger_updated_at'), 'passenger', ['updated_at'], unique=False)
    op.create_table('driver',
    sa.Column('d_id', sa.BigInteger(), nullable=False),
    sa.Column('name', sa.String(length=40), nullable=False),
    sa.Column('license_no', sa.String(), nullable=False),
    sa.Column('address', sa.Text(), nullable=True),
    sa.Column('mobile', sa.String(length=10), nullable=False),
    sa.Column('experience_year', sa.Integer(), nullable=True),
    sa.Column('password_hash', sa.String(), nullable=True),
    sa.Column('email', sa.String(), nullable=True),
    sa.Column('fleet_id', sa.BigInteger(), nullable=True),
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['fleet_id'], ['fleet.f_id'], ),
    sa.PrimaryKeyConstraint('d_id')
    )
    op.create_index(op.f('ix_driver_created_at'), 'driver', ['created_at'], unique=False)
    op.create_index(op.f('ix_driver_email'), 'driver', ['email'], unique=True)
    op.create_index(op.f('ix_driver_license_no'), 'driver', ['license_no'], unique=True)
    op.create_index(op.f('ix_driver_mobile'), 'driver', ['mobile'], unique=True)
    op.create_index(op.f('ix_driver_name'), 'driver', ['name'], unique=False)
    op.create_index(op.f('ix_driver_updated_at'), 'driver', ['updated_at'], unique=False)
    op.create_table('ride',
    sa.Column('r_id', sa.BigInteger(), nullable=False),
    sa.Column('start_location', sa.String(), nullable=False),
    sa.Column('dest_location', sa.String(), nullable=False),
    sa.Column('via_route', sa.Text(), nullable=True),
    sa.Column('estimated_dist', sa.Float(), nullable=True),
    sa.Column('actual_dist', sa.Float(), nullable=True),
    sa.Column('estimated_cost', sa.Float(), nullable=True),
    sa.Column('actual_cost', sa.Float(), nullable=True),
    sa.Column('ride_gpx_path', sa.String(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('driver_id', sa.BigInteger(), nullable=True),
    sa.Column('passenger_id', sa.BigInteger(), nullable=True),
    sa.Column('started_at', sa.DateTime(), nullable=False),
    sa.Column('ended_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['driver_id'], ['driver.d_id'], ),
    sa.ForeignKeyConstraint(['passenger_id'], ['passenger.p_id'], ),
    sa.PrimaryKeyConstraint('r_id'),
    sa.UniqueConstraint('ride_gpx_path')
    )
    op.create_index(op.f('ix_ride_ended_at'), 'ride', ['ended_at'], unique=False)
    op.create_index(op.f('ix_ride_started_at'), 'ride', ['started_at'], unique=False)
    op.create_index(op.f('ix_ride_status'), 'ride', ['status'], unique=False)
    op.create_table('vehicle',
    sa.Column('v_id', sa.String(), nullable=False),
    sa.Column('v_type', sa.String(), nullable=False),
    sa.Column('manufacturer', sa.String(), nullable=False),
    sa.Column('model', sa.String(), nullable=False),
    sa.Column('fuel_type', sa.String(), nullable=False),
    sa.Column('driver_id', sa.BigInteger(), nullable=True),
    sa.Column('fleet_id', sa.BigInteger(), nullable=True),
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.Column('updated_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['driver_id'], ['driver.d_id'], ),
    sa.ForeignKeyConstraint(['fleet_id'], ['fleet.f_id'], ),
    sa.PrimaryKeyConstraint('v_id')
    )
    op.create_index(op.f('ix_vehicle_created_at'), 'vehicle', ['created_at'], unique=False)
    op.create_index(op.f('ix_vehicle_manufacturer'), 'vehicle', ['manufacturer'], unique=False)
    op.create_index(op.f('ix_vehicle_model'), 'vehicle', ['model'], unique=False)
    op.create_index(op.f('ix_vehicle_updated_at'), 'vehicle', ['updated_at'], unique=False)
    op.create_index(op.f('ix_vehicle_v_type'), 'vehicle', ['v_type'], unique=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_vehicle_v_type'), table_name='vehicle')
    op.drop_index(op.f('ix_vehicle_updated_at'), table_name='vehicle')
    op.drop_index(op.f('ix_vehicle_model'), table_name='vehicle')
    op.drop_index(op.f('ix_vehicle_manufacturer'), table_name='vehicle')
    op.drop_index(op.f('ix_vehicle_created_at'), table_name='vehicle')
    op.drop_table('vehicle')
    op.drop_index(op.f('ix_ride_status'), table_name='ride')
    op.drop_index(op.f('ix_ride_started_at'), table_name='ride')
    op.drop_index(op.f('ix_ride_ended_at'), table_name='ride')
    op.drop_table('ride')
    op.drop_index(op.f('ix_driver_updated_at'), table_name='driver')
    op.drop_index(op.f('ix_driver_name'), table_name='driver')
    op.drop_index(op.f('ix_driver_mobile'), table_name='driver')
    op.drop_index(op.f('ix_driver_license_no'), table_name='driver')
    op.drop_index(op.f('ix_driver_email'), table_name='driver')
    op.drop_index(op.f('ix_driver_created_at'), table_name='driver')
    op.drop_table('driver')
    op.drop_index(op.f('ix_passenger_updated_at'), table_name='passenger')
    op.drop_index(op.f('ix_passenger_name'), table_name='passenger')
    op.drop_index(op.f('ix_passenger_mobile'), table_name='passenger')
    op.drop_index(op.f('ix_passenger_email'), table_name='passenger')
    op.drop_index(op.f('ix_passenger_created_at'), table_name='passenger')
    op.drop_table('passenger')
    op.drop_index(op.f('ix_fleet_updated_at'), table_name='fleet')
    op.drop_index(op.f('ix_fleet_created_at'), table_name='fleet')
    op.drop_table('fleet')
    # ### end Alembic commands ###
